include	iost.inc
include	io.inc
include	string.inc
ifdef __TE__
include	conio.inc
include	tinfo.inc
tiofread proto
endif
ifdef __MEMVIEW__
	extrn tvmem_size: DWORD
	extrn tvmem_offs: DWORD
endif
ifdef __ZIP__
	extrn odecrypt: NEAR
endif

	.data
	oupdate	p? 0
public	oupdate

	.code

ofread	proc _CType public uses rsi rdi
	mov	rsi,STDI.ios_flag
  ifdef __MEMVIEW__
	test	rsi,IO_MEMREAD
	jnz	ofread_memory
  endif
  ifdef __TE__
	test	rsi,IO_LINEBUF
	jnz	ofread_linebuf
  endif
	mov	rdi,STDI.ios_c
	sub	rdi,STDI.ios_i
	jnz	ofread_copy
    ofread_read:
	xor	rax,rax
	mov	STDI.ios_i,rax
	mov	STDI.ios_c,rdi
	mov	rcx,STDI.ios_size
	sub	rcx,rdi
	lodm	STDI.ios_bp
	add	rax,rdi
	invoke	osread,STDI.ios_file,dxax,rcx
	add	STDI.ios_c,rax
	add	rax,rdi
	jz	ofread_end
	and	rsi,IO_UPDTOTAL or IO_USECRC or IO_USEUPD or IO_CRYPT
	jnz	ofread_user
    ofread_end:
	test	rax,rax
	ret
  ifdef __MEMVIEW__
    ofread_memory:
	call	iomemread
	jmp	ofread_end
  endif
  ifdef __TE__
    ofread_linebuf:
	call	tiofread
	jmp	ofread_end
  endif
    ofread_user:
  ifdef __ZIP__
	test	rsi,IO_CRYPT
	jz	@F
	call	odecrypt
    @@:
  endif
	test	rsi,IO_UPDTOTAL
	jz	ofread_crc
      ifdef __f__
	add	STDI.ios_total,eax
      else
	add	word ptr STDI.ios_total,ax
	adc	word ptr STDI.ios_total+2,0
      endif
    ofread_crc:
	test	rsi,IO_USECRC
	jz	ofread_progress
	mov	rdx,rdi
	mov	rsi,offset STDI
	call	oupdcrc
	mov	rsi,STDI.ios_flag
    ofread_progress:
	test	rsi,IO_USEUPD
	jz	ofread_end
      ifdef __CDECL__
	push	0
	push	rax
      else
	push	rax
	push	0
      endif
	call	oupdate
	dec	rax
	pop	rax
	jnz	ofread_error
	jmp	ofread_end
    ofread_copy:
	cmp	rdi,STDI.ios_c
	je	ofread_eof
	lodm	STDI.ios_bp
	add	rax,STDI.ios_i
	invoke	memcpy,STDI.ios_bp,dxax,rdi
	jmp	ofread_read
    ofread_error:
	call	osmaperr
	or	STDI.ios_flag,IO_ERROR
    ofread_eof:
	xor	rax,rax
	jmp	ofread_end
ofread	ENDP

ifdef __MEMVIEW__

iomemread PROC
  ifdef __386__
	mov	eax,tvmem_size
	cmp	eax,STDI.ios_offset
	jbe     iomemread_02
	mov	eax,STDI.ios_offset
	push	STDI.ios_bp
	mov	dx,ax
	and	dx,000Fh
	and	al,0F0h
	shl	eax,12
	mov	ax,dx
	push	eax
	mov	ecx,STDI.ios_offset
	xor	eax,eax
	mov	STDI.ios_i,ax
	cmp	ax,STDI.ios_c
	mov	ax,STDI.ios_size
	mov	STDI.ios_c,ax
	jz	@F
	add	ecx,eax
	cmp	ecx,tvmem_size
	jbe	@F
	sub	ecx,eax
	mov	eax,tvmem_size
	sub	eax,ecx
	mov	STDI.ios_c,ax
	add	ecx,eax
      @@:
	mov	STDI.ios_offset,ecx
	push	STDI.ios_c
	call	memcpy
	mov	ax,1
	ret
    iomemread_02:
	mov	STDI.ios_offset,eax
  else
	lodm	tvmem_size
	cmp	dx,word ptr STDI.ios_offset+2
	jne	@F
	cmp	ax,word ptr STDI.ios_offset
      @@:
	jbe     iomemread_02
	pushm	STDI.ios_bp
	lodm	STDI.ios_offset
	mov	bx,ax
	and	bx,000Fh
	shl	dx,12
	shr	ax,4
	or	dx,ax
	push	dx
	push	bx
	xor	ax,ax
	mov	STDI.ios_i,ax
	cmp	ax,STDI.ios_c
	mov	dx,word ptr STDI.ios_offset+2
	mov	cx,word ptr STDI.ios_offset
	mov	ax,STDI.ios_size
	mov	STDI.ios_c,ax
	jz	@F
	add	cx,ax
	adc	dx,0
	cmp	dx,word ptr tvmem_size+2
	jbe	@F
	mov	dx,word ptr STDI.ios_offset+2
	mov	cx,word ptr STDI.ios_offset
	mov	ax,word ptr tvmem_size
	mov	bx,word ptr tvmem_size+2
	sub	ax,cx
	sbb	bx,dx
	mov	STDI.ios_c,ax
	add	cx,ax
	adc	dx,bx
      @@:
	mov	word ptr STDI.ios_offset,cx
	mov	word ptr STDI.ios_offset+2,dx
	push	STDI.ios_c
	call	memcpy
	mov	ax,1
	ret
    iomemread_02:
	stom	STDI.ios_offset
  endif
	xor	ax,ax
	mov	STDI.ios_i,ax
	mov	STDI.ios_c,ax
	ret
iomemread ENDP

endif

	END
